/*
    Write by LinJiangHua(xempo) 8-2011
    Copyright LinJiangHua 8-2011
*/

#ifndef  _IMAGE_FILE_VIEW
#define  _IMAGE_FILE_VIEW

#include <qiconview.h>
#include "fastblock.h"

extern const char vIcon[];

class Filesan;
class QTextCodec;

class IVItem : public QIconViewItem
{
public :
IVItem(QIconView *view, IVItem *ico, const char *txt, const QPixmap &pix, QTextCodec *code, bool isdir , bool can_drop);
IVItem(QIconView *view, IVItem *ico, const char *txt, bool isdir, bool can_drop);
~IVItem();
char *fnam;
void _setName(const char *nam);

bool isDir() const
{ return _dir; }

bool getCanDrop() const
{ return _canDrop; }

virtual bool acceptDrop( const QMimeSource *e ) const;

protected :
virtual void dragLeft();
virtual void dragEntered();
virtual void dropped( QDropEvent *e, const QValueList<QIconDragItem> & );

private :
bool _canDrop, _dir;
};

class ImageFileView : public QIconView
{
public :
ImageFileView(QWidget *);
void selectedCollect(FastBlock *lst);
void restoreIcon();

void setSelStat(IVItem *ico);

void endTimer();

IVItem * getSelItem() const
{ return selItem; }

Filesan *_filesor() const
{ return filesor; }

IVItem *Index(int idx);
void setTms(int t){ tms=t; }

protected :
QDragObject *dragObject();
bool event( QEvent * );

private :
int testFile(IVItem *, char *pt);
int testResult, tms;

Filesan *filesor;
IVItem  *dragIcon, *selItem;
QPixmap dragOpen, oldpix;
};

#endif
