/*
  Write & edit by Linjianghua 2004-2006, 2014
  Free under LGPL
*/

#ifndef  FSP_IO
#define  FSP_IO

#include "envpath.h"

typedef enum { RScript=1, CompactMsg=2, FspError=4, OpenLastDir=8,
	ScriptError=16, FspOpenInfo=32, OpenAlway=64,
	HasFullPath=256,  FastBuf=512,  DectName=1024
	}OpenSpace;

extern const char ExtFSP[];
extern StrList fspPaths;

extern fsp_lib *fspAlloc();

__BEGIN_DECLS
extern fsp_lib *fspOpen(const char *fname, int dect/* show fail-msg, such pluzone...*/);
extern void fspClose(fsp_lib *,fsp_lib* (*Compr)(fsp_lib *,const char *, int msg));
__END_DECLS

#endif
