/*
	Write & edit by Linjianghua(xempo)
	Copyright 2005 Linjianghua(xempo), 2012
	Reserve all rights of this file
*/

#define	BOOL	
/* use cc, not c++ */

#include "readfile.c"

#ifdef	_LINUX_SOURCE
#include <unistd.h>
#define	stricmp	strcasecmp
#define DIV_CH   '/'
#else
#include <dos.h>
#define DIV_CH   '\\'
#endif

#include <time.h>
#include <sys/stat.h>
#include "memstr.c"

static const char memblkcmp[7]={10,13,32, 9, ',' , ';' };

inline char *numbcode(char *chs)
{
  char ch;
  int i;
  for(i=0;(ch=chs[i])>47&&ch<58||ch=='-'||ch=='+';i++);
  return chs+i;
}

static int ToNextLen(const char *pt)
{
  int i;
  for(i=0; strchr("\r\n\t ",pt[i]); i++);
  return i;
}

static void namext(char *buff, const char *name, const char *ext, const char *dst)
{
 char *ptr;
  if(dst){
	int L=strlen(dst);
	scopy(buff, dst);
	ptr=strrchr(name, DIV_CH);
	if(ptr){
		if(dst[L-1]=='/')L--;
		scopy(buff+L, ptr);
		}
	else {
		buff[L++]='/';
		scopy(buff+L, name);
		}
	}
  else scopy(buff,name);
  ptr=strrchr(buff,'.');
  if(ptr)scopy(ptr,ext);
  else strcat(buff,ext);
}

static void PutInto(FILE *fout, const char *fmt,
	const char *endchs, const char *buf,unsigned len)
{
fwrite(fmt,strlen(fmt),1,fout);
fwrite(buf, len,1,fout);
fwrite(endchs, strlen(endchs),1,fout);
}

#define FmtMultSyb(chr) (chr==32||chr==9 ? ',':chr)
#define  _Mode  7
int main(int argc,char **argv)
{
static const char *pms_mode[_Mode]={ "--C-code", "--define", "--void", "--free", "--short", "--FSP", "--RTL" },
*vext[3]={ ".sor", ".val", NULL },*dext[3]={ ".csc", ".chs", ".h" },
usageChs[]="Usage : sepa [filename] |[--C-code |--define] |[-d <target-dir>]\n\
\tFreely txt-mode,  sepa-symbol(4):  [SPACE] [Tab] [Enter] , ;\n\
\t\"--C-code\" out 2 C/C++ file as chars(*.chs), vals(*.val)\n\
\t\"--define\" create a C/C++ precompile file(*.h)\n\
\totherwise out 2 files, one is fsplus-script(*.csc), one is sort(*.sor) which temp\n\
\t--void  specied type is void\n\
\t--free  cut 2 side [Enter] or [Space] [tab]\n\
	default is cvt dos-mode to Unix-mode(t)\n\
\t--short  --C-code for int is short\n\
\t\"-d\" is specied dir for out\n";

if(argc>1){
 unsigned int len;
 int i, j, b, c=0, m=0, FreeOff, vlen=2, chrlen=0, t1, d_len, msg=0,
	*pmpos=(int *)malloc((argc-1)*sizeof(int));
 FILE *fchr, *fval;
 static const char WB[]="wb";
 char *p_d, *valbuf, *chrbuf, *pt, chr, *buffers, *pRt,
 fVal[200], pCxb[200];
 struct stat st;
 const char  *dstdir=NULL, *src=NULL,
	*libnam="ROSE",
	*numbsetMode="numbset 1 -t=i\n{",
	*type="numbset 0 -t=t\n{\n";
 for(i=0; i<argc-1; i++)pmpos[i]=-1;
 for(i=0; i<_Mode; i++)
     for(j=1; j<argc; j++)if(strcmp(pms_mode[i],argv[j])==0){
	switch(i){
	case 2 : type="numbset 0 -t=v\n{\n";
		goto _pos_;
	case 3 : type="numbset 0 -t=y\n{\n";
		goto _pos_;
	case 4 : numbsetMode="numbset 1 -t=s\n{";
		goto _pos_;
	case 5 : libnam="FSP";
		goto _pos_;
	case 6 : libnam="RTL";
		goto _pos_;
	default : {
	   if(m&&m!=i+1){
		printf("%s can't use with %s\n", pms_mode[i], pms_mode[m-1]);
		return -1;
		}
	   m=i+1;	b=j; /* pos */
_pos_:	   pmpos[c++]=j;
	   }
	}
     }

 for(i=1; i<argc; i++)if(strcmp("-d", argv[i])==0){
	if(b==i+1 || i+1>=argc ){
		if(dstdir==NULL){
			printf("A dir must follow \"-d\" for out !\n");
			pmpos[c++]=i;
		}
		continue;
		}
	if(stat(argv[i+1], &st) || (st.st_mode&S_IFDIR)==0 )printf("\"-d\" specied \"%s\" is not existed dir !\n", argv[i+1]);
	else if(dstdir)printf("Out dir has specied \"%s\", \"%s\" not be use !\n", dstdir, argv[i+1]);
	         else dstdir=argv[i+1];
	pmpos[c++]=i;		pmpos[c++]=++i;
	}

 for(i=1; i<argc; i++)if(*argv[i]!='-'){
	if(argv[i]!=dstdir)
		if(stat(argv[i], &st)==0 && (st.st_mode&S_IFDIR)==0 ){
		src=argv[i];
		pmpos[c++]=i;
		break;
		}
	}

 if(c<argc-1)for(i=1; i<argc; i++){
	for(j=0; j<c&&pmpos[j]!=i; j++);
	if(j>=c)printf("** Warn ! \"%s\" is not use param\n", argv[i]);
	}

 if(src==NULL){ printf("No source file input\n"); goto errpm; }

 p_d=strchr(*argv,DIV_CH);
 if(p_d){	*p_d=0;
	_ProgPath=*argv;
	}
 buffers=ReadFile(src,&len);
 if(buffers){
   namext(pCxb, src, dext[m], dstdir );
   fchr=fopen(pCxb,WB);
   if(fchr==NULL){
	perror(pCxb);
	return -1;
	}
   if(m<2){
	namext(fVal, src, vext[m], dstdir);
	fval=fopen(fVal,WB);
	if(fval==NULL){
		perror(fVal);
		return -1;
		}
	}
   else {
	char buf[80];
	time_t tm;
	time(&tm);
	sprintf(buf, "*/\n\n#ifndef\t%s_commands\n#define\t%s_commands\n\n", libnam, libnam);
	fprintf(fchr, "%s%s%s", "/*\n\tCreate by sepa\n\t\t",ctime(&tm), buf);
	}
/*===============================================*/
    len=strlen(buffers)+1;
    chrbuf=(char *)malloc(len*2+12);
    valbuf=chrbuf+len+4;
    while(*buffers==32||*buffers==9)buffers++;
    pt=buffers;
    for(i=0,b=0;i<len;i++){
      chr=buffers[i];
      if(memchr(memblkcmp,chr,7)){
	FreeOff=ToNextLen(pt);
	pt+=FreeOff;
	p_d=numbcode(pt);
	t1=p_d-pt;
	d_len= i-(b+FreeOff) -t1;
	if(pt[0]=='/'&&pt[1]=='/'){ /* ignore(skip)  .... */
		c=i;
		for(j=0; pt[j]!='\n'&&/*pt[j]!='\r'&&*/pt[j]; j++)if(pt+j>buffers+c)i++;
		while(pt[j]=='\n'/*||pt[j]=='\r'*/){ j++; i++; }
		goto _skp_;
		}
	if(pt!=buffers){
	    pRt=memstr(buffers,b, p_d, d_len, 3);
	    if(pRt && (pRt[-1]>='0'&&pRt[-1]<='9') && memchr(memblkcmp, pRt[d_len], 7) ){
		p_d[d_len]=0;
		printf("mult define : %s\n ** fail !\n", p_d);
		return -1;		
		}
	    pRt=memstr(buffers,b, pt, t1, 3);
	    if(pRt && strchr(memblkcmp, pRt[-1]) && (pRt[t1]<'0' || pRt[t1]>'9') ){
		char c2=p_d[d_len];
		p_d[d_len]=0;
		printf("*** Warn ***\nmult set value : %s\n", pt);
		p_d[d_len]=c2;
		}
	}
	if(msg){
		msg=0;
		if(m==2){
			char *bu=(char *)malloc(t1+4);
			fprintf(fchr, "#define  %s_", libnam);
			fwrite(p_d, d_len, 1, fchr);
			bu[0]='\t';	bu[1]='\t';
			for(j=0; j<t1; j++)bu[j+2]=pt[j];
			bu[t1+2]='\n';
			fwrite(bu, t1+3, 1, fchr);
		}
		else {
			for(j=0; j<d_len; j++)chrbuf[chrlen++]=p_d[j];
			chrbuf[chrlen++]=FmtMultSyb(chr);  /* fmt SPACE & Tab to ',' */
			for(j=0;j<t1;j++)valbuf[vlen++]=pt[j];
			valbuf[vlen++]=FmtMultSyb(chr);
			}
		}
	  else if(m<2){
		chrbuf[chrlen-1]=FmtMultSyb(chr);
		valbuf[vlen-1]=FmtMultSyb(chr);
		}
	_skp_: b=i+1;	pt=buffers+b;
    	}
       else msg=1;
    }

    if(m<2){
	valbuf[0]=10; valbuf[1]=10;
	switch(m){
	case 1 : for(i=0;i<chrlen-1;i++)
			if(strchr(memblkcmp,chrbuf[i]))chrbuf[i]=',';
		PutInto(fchr, "comchs=\"", "\";\n", chrbuf, chrlen-1);
		for(i=2;i<vlen-3; i++)if('\n'==valbuf[i])valbuf[i]=',';
		PutInto(fval, "static const _Int vals[]={", " };\n", valbuf+2, vlen-3);
		break;
	case 0 : PutInto(fchr, type, "\n}\n\n", chrbuf,chrlen-1 );
		PutInto(fchr, numbsetMode, "\n}", valbuf+1, vlen-2 );

		fwrite(chrbuf,chrlen-1,1,fval);
		fwrite(valbuf,vlen-1,1,fval);
		}
	fclose(fval);
/*    free(chrbuf); redure code */
	printf("Sepa created :\n  \"%s\"\n  \"%s\"\n",fVal,pCxb);
    }
    else {
	printf("Sepa created :   \"%s\"\n",pCxb);
	fprintf(fchr, "\n#endif\n");
	}
    fclose(fchr);
    return 0; /* for make.exe */
    }
    printf("\n");
/* Null */
 }
else errpm: printf(usageChs);
return -1; /* for make.exe */
}
