/*
	Write by xempo(LinJiangHua) 8-2015
	Free under LGPL
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <dirent.h>
#include <sys/stat.h>

#include "catstr.c"

#define  prgCount  2
static const char *prgName[prgCount]={".fsplus-3.5.2", ".pluzone-1.4.2" };

static void clearUser(const char *dn)
{
char *cmd, *prg;
int i;
for(i=0; i<prgCount; i++){
	prg=catstr(dn, prgName[i], '/');
	cmd=catstr("rm -fr", prg, 32);
	free(prg);
	system(cmd);
//		puts(cmd);
	free(cmd);
	}
}

int main(int argc, char **argv)
{
char *dn, *nam, *home;
struct dirent *dire;
struct stat st;
DIR *dir;
home= argc<2 ? "/home" : argv[1] ;
dir=opendir(home);
if(dir==NULL){
	printf("Can't open %s\n", home);
	return -1;
}
while( (dire=readdir(dir)) ){
	nam=dire->d_name;
	if( ! (nam[0]=='.' && (nam[1]==0 ||( nam[1]=='.'&&nam[2]==0))) ){
		dn=catstr(home, nam, '/');
		stat(dn, &st);
		if(S_ISDIR(st.st_mode))clearUser(dn);
		
	}
}
clearUser(getenv("HOME"));
return 0;
}
